<?php
/**
 *  Copyright 2007, 2008, 2009 Yuri Timofeev tim4dev@gmail.com
 *
 * This file is part of Webacula.
 *
 * Webacula is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Webacula is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Webacula.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Class for Logbook
 *
 * @package    webacula
 * @author Yuri Timofeev <tim4dev@gmail.com>
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU Public License
 */


class Wbjobdesc extends Zend_Db_Table
{
    public $db_adapter;

    public function __construct($config = array())
    {
        $this->db_adapter  = Zend_Registry::get('DB_ADAPTER_WEBACULA');
        $config['db']      = Zend_Registry::get('db_webacula'); // database
        $config['sequence']= true;
        parent::__construct($config);
    }

    protected function _setupTableName()
    {
        switch ($this->db_adapter) {
        case 'PDO_PGSQL':
            $this->_name = 'wbjobdesc';
            break;
        default:  // including mysql, sqlite
            $this->_name = 'wbJobDesc';
        }
        parent::_setupTableName();
    }

    protected function _setupPrimaryKey()
    {
        $this->_primary = 'desc_id';
        parent::_setupPrimaryKey();
    }

    public function init() {
        $db = Zend_Db_Table::getAdapter('db_webacula');
        switch ($this->db_adapter) {
            case 'PDO_MYSQL':
                $db->query('SET NAMES utf8');
                $db->query('SET CHARACTER SET utf8');
                break;
            case 'PDO_PGSQL':
                $db->query("SET NAMES 'UTF8'");
                break;
        }
    }


}